<template>
  
  <b-nav-item-dropdown right toggle-class="d-flex align-items-center dropdown-user-link" class="dropdown-user" v-if="userData" >
    <template #button-content>
      <b-img v-if="userProfilePhoto != ''" :src="userProfilePhoto" class="box-shadow-none user-logo" />
      <IconUserProfile v-if="userProfilePhoto == ''" class="box-shadow-none"></IconUserProfile>
    </template>
    <div link-class="d-flex align-items-center">
      <div class="profile-dropdown-header">
        <h4 class="company-header-name">
          {{ userData && userData.company ? userData.company.name : "Event Better" }}
        </h4>
        <div class="user-details">
          <div class="dd-user-logo">
            <b-img v-if="userProfilePhoto != ''" :src="userProfilePhoto" class="box-shadow-none dd-user-logo" />
            <IconUserProfile v-if="userProfilePhoto == ''" class="box-shadow-none dd-user-logo"></IconUserProfile>
          </div>
          <b-form-group>
            <b-form-input class="dd-username" disabled v-model="userData.name" />
          </b-form-group>
        </div>
      </div>
    </div>
    <hr />
    <b-dropdown-item link-class="d-flex align-items-center" :to="{ name: 'user-profile' }">
      <IconProfile class="dd-item-svg"></IconProfile> <span class="dd-item-title"> Profile</span>
    </b-dropdown-item>

    <b-dropdown-item link-class="d-flex align-items-center" @click="changePasswordModalToggle()">
      <IconChangePassword class="dd-item-svg"></IconChangePassword> <span class="dd-item-title"> Change
        Password</span>
    </b-dropdown-item>
    <!-- Status Confirm Modal -->
    <b-modal ref="changePasswordModal" id="changePasswordModal" size="md" hide-footer>
       <div id="passwordModal" class="change-password-modal form-card">
          <div class="event-blocked-header mheader shadow">
            <IconChangePassword class="dd-item-svg" />
            <h4 class="title mb-0">
              <span class="color-theme">Change </span>
              <span class="color-black">Password</span>
            </h4>
          </div>
          <div>
            <b-form-group>
              <label class="d-block" for="emailId">Email ID</label>
                <b-form-input id="emailId" class="text-transform-none" v-model="userData.email"
                   placeholder="Email ID" :disabled="true" 
                   :state="errors.email && errors.email.length > 0 ? false : null"
                    @input="checkValidation('email')" @blur="checkValidation('email')"/>
                
                  <small class="text-danger">{{ errors.email ? errors.email[0] : '' }}</small>
             </b-form-group>
            <b-form-group label-for="currentPassword" class="form-group d-block mt-1">
              <label class="form-label" for="current_password">Current Password<span class="text-danger">
                  *</span></label>
                <b-input-group class="input-group-merge" :class="{ 'is-invalid': errors.currentPassword?.length > 0 }">
                  <b-form-input name="current_password" ref="current_password" id="current_password"
                    placeholder="Enter Current Password" class="text-transform-none"
                     v-model="currentPassword" autofocus
                    maxlength="50" :type="passwordFieldType" 
                    :state="errors.currentPassword && errors.currentPassword.length > 0 ? false : null"
                    @input="checkValidation('currentPassword')" @blur="checkValidation('currentPassword')"/>
                   <b-input-group-append is-text @click="togglePasswordVisibility">
                    <svg xmlns="http://www.w3.org/2000/svg" v-if="passwordFieldType === 'password'"  width="14px" height="14px" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-eye-off cursor-pointer" size="14px"><path d="M17.94 17.94A10.07 10.07 0 0 1 12 20c-7 0-11-8-11-8a18.45 18.45 0 0 1 5.06-5.94M9.9 4.24A9.12 9.12 0 0 1 12 4c7 0 11 8 11 8a18.5 18.5 0 0 1-2.16 3.19m-6.72-1.07a3 3 0 1 1-4.24-4.24"></path><line x1="1" y1="1" x2="23" y2="23"></line></svg>
                    <svg xmlns="http://www.w3.org/2000/svg" v-if="passwordFieldType != 'password'" width="14px" height="14px" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-eye cursor-pointer" size="14px"><path d="M1 12s4-8 11-8 11 8 11 8-4 8-11 8-11-8-11-8z"></path><circle cx="12" cy="12" r="3"></circle></svg>
                  </b-input-group-append>
                </b-input-group>
                <small class="text-danger">{{ errors.currentPassword ? errors.currentPassword[0] : '' }}</small>
                 

            </b-form-group>
            <b-form-group label-for="newPassword" class="form-group d-block mt-1">
              <label class="form-label" for="SOSPasswordId">New Password<span class="text-danger"> *</span></label>
               <b-input-group class="input-group-merge" :class="{ 'is-invalid': errors.newPassword?.length > 0 }">
                  <b-form-input name="new_password" ref="new_password" id="newPasswordId"
                    placeholder="Enter New Password" class="text-transform-none"
                    :state="errors.newPassword && errors.newPassword.length > 0 ? false : null"
                    @input="checkValidation('newPassword')" @blur="checkValidation('newPassword')"
                     v-model="newPassword" maxlength="50"
                    :type="newPasswordFieldType" />
                  <b-input-group-append is-text @click="toggleNewPasswordVisibility">
                    <svg xmlns="http://www.w3.org/2000/svg" v-if="newPasswordFieldType === 'password'"  width="14px" height="14px" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-eye-off cursor-pointer" size="14px"><path d="M17.94 17.94A10.07 10.07 0 0 1 12 20c-7 0-11-8-11-8a18.45 18.45 0 0 1 5.06-5.94M9.9 4.24A9.12 9.12 0 0 1 12 4c7 0 11 8 11 8a18.5 18.5 0 0 1-2.16 3.19m-6.72-1.07a3 3 0 1 1-4.24-4.24"></path><line x1="1" y1="1" x2="23" y2="23"></line></svg>
                    <svg xmlns="http://www.w3.org/2000/svg" v-if="newPasswordFieldType != 'password'" width="14px" height="14px" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-eye cursor-pointer" size="14px"><path d="M1 12s4-8 11-8 11 8 11 8-4 8-11 8-11-8-11-8z"></path><circle cx="12" cy="12" r="3"></circle></svg>
                  </b-input-group-append>
                </b-input-group>
                <small class="text-danger">{{ errors.newPassword ? errors.newPassword[0] : '' }}</small>
            </b-form-group>
            <b-form-group label-for="updateConfirmSOSPassword" class="form-group d-block mt-1">
              <label class="form-label" for="confirmNewPasswordId">Confirm Password<span class="text-danger">
                  *</span></label>
              <b-input-group class="input-group-merge" :class="{ 'is-invalid': errors.confirmNewPassword?.length > 0 }">
                  <b-form-input id="confirmNewPasswordId" placeholder="Enter Confirm Password"
                    v-model="confirmNewPassword" class="text-transform-none" 
                    :state="errors.confirmNewPassword && errors.confirmNewPassword.length > 0 ? false : null"
                    @input="checkValidation('confirmNewPassword')" @blur="checkValidation('confirmNewPassword')"
                    value="" data-vv-as="new_password" maxlength="50"
                    :type="confirmPasswordFieldType" />
                  <b-input-group-append is-text @click="toggleConfirmPasswordVisibility">
                    <svg xmlns="http://www.w3.org/2000/svg" v-if="confirmPasswordFieldType === 'password'"  width="14px" height="14px" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-eye-off cursor-pointer" size="14px"><path d="M17.94 17.94A10.07 10.07 0 0 1 12 20c-7 0-11-8-11-8a18.45 18.45 0 0 1 5.06-5.94M9.9 4.24A9.12 9.12 0 0 1 12 4c7 0 11 8 11 8a18.5 18.5 0 0 1-2.16 3.19m-6.72-1.07a3 3 0 1 1-4.24-4.24"></path><line x1="1" y1="1" x2="23" y2="23"></line></svg>
                    <svg xmlns="http://www.w3.org/2000/svg" v-if="confirmPasswordFieldType != 'password'" width="14px" height="14px" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-eye cursor-pointer" size="14px"><path d="M1 12s4-8 11-8 11 8 11 8-4 8-11 8-11-8-11-8z"></path><circle cx="12" cy="12" r="3"></circle></svg>
                  </b-input-group-append>
                </b-input-group>
                <small class="text-danger">{{ errors.confirmNewPassword ? errors.confirmNewPassword[0] : '' }}</small>
            </b-form-group>
            <div>
              <center>
                <b-button variant="primary" class="btn-submit-edit mt-1 block-button" type="submit"
                  @click.prevent="changePassword" :disabled="isChangePasswordSubmit">
                  <b-spinner small v-if="isChangePasswordSubmit" />
                  <span class="mr-25 align-middle px-1">Done</span>
                </b-button>
              </center>
            </div>
          </div>
        </div>
    </b-modal>
    <hr />
    <b-dropdown-item link-class="d-flex align-items-center" @click="logout">
      <IconSignOut class="dd-item-svg"></IconSignOut> <span class="dd-item-title"> Sign out</span>
    </b-dropdown-item>
  </b-nav-item-dropdown>
</template>

<script>
import {
  BNavItemDropdown,
  BDropdownItem,
  BDropdownDivider,
  BAvatar,
  BImg,
  BModal,
  BFormGroup,
  BButton,
  BFormInput,
  BSpinner,
  BInputGroup,
  BInputGroupAppend,
} from "bootstrap-vue";
import {UsersIcon} from 'vue-feather-icons';
import { initialAbility } from "@/libs/acl/config";
import useJwt from "@/auth/jwt/useJwt";
import useAppConfig from "@core/app-config/useAppConfig";

import store from "@/store";
import userService from "./service";
import { onUnmounted } from "vue";
import ToastificationContent from "@core/components/toastification/ToastificationContent.vue";
import {
  togglePasswordVisibility,
  toggleNewPasswordVisibility,
  toggleConfirmPasswordVisibility,
} from "@core/mixins/ui/forms";
import { useToast } from "vue-toastification";
const toast = useToast();
export default {
  components: {
    BNavItemDropdown,
    BDropdownItem,
    BDropdownDivider,
    BAvatar,
    BImg,
    BModal,
    BButton,
    BFormGroup,
    BFormInput,
    BSpinner,
    BInputGroup,
    BInputGroupAppend,
    UsersIcon
  },
  mixins: [
    togglePasswordVisibility,
    toggleNewPasswordVisibility,
    toggleConfirmPasswordVisibility,
  ],
  computed: {
    passwordToggleIcon() {
      return this.passwordFieldType === "password" ? "EyeOffIcon" : "EyeIcon";
    },
    newPasswordToggleIcon() {
      return this.newPasswordFieldType === "password" ? "EyeOffIcon" : "EyeIcon";
    },
    confirmPasswordToggleIcon() {
      return this.confirmPasswordFieldType === "password" ? "EyeOffIcon" : "EyeIcon";
    },
  },
  setup() {
    var { userProfilePhoto } = useAppConfig();
    const userData = JSON.parse(localStorage.getItem("userData"));

    store.commit("appConfig/UPDATE_USER_PROFILE_PHOTO", {
      profilePhoto: (userData && userData.profile) ? import.meta.env.VITE_API_URL + userData.profile : '',
    });

    const MODULE_NAME = "user-nav";
    // Register module
    if (!store.hasModule(MODULE_NAME)) store.registerModule(MODULE_NAME, userService);
    // UnRegister on leave
    onUnmounted(() => {
      // if (store.hasModule(MODULE_NAME)) store.unregisterModule(MODULE_NAME);
    });
    return {
      userData,
      userProfilePhoto,
      currentPassword: "",
      newPassword: "",
      confirmNewPassword: "",
      isChangePasswordSubmit: false,
    };
  },
  data() {
    return {
      errors: {}
    };
  },
  methods: {
    validateEmail(email) {
      return email.match(
        /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/
      );
    },
    checkValidation(field = '*') {
      if (field == '*' || field == 'email') {
        if (!this.userData['email']) {
          this.errors['email'] = ['Please enter Email ID'];
        } else if(!this.validateEmail(this.userData['email'])){
          this.errors['email'] = ["Please enter valid Email ID"];
        } else {
          delete this.errors['email'];
        }
      }
      if (field == '*' || field == 'currentPassword') {
        if (!this.currentPassword) {
          this.errors['currentPassword'] = ['Please enter Current Password'];
        } else {
          delete this.errors['currentPassword'];
        }
      }
      if (field == '*' || field == 'newPassword') {
        if (!this.newPassword) {
          this.errors['newPassword'] = ['Please enter New Password'];
        } else if (this.newPassword.length < 6) {
          this.errors['newPassword'] = ['New Password must be at least 6 characters'];
        } else {
          delete this.errors['newPassword'];
        }
      }
   
   if (field == '*' || field == 'confirmNewPassword') {
     if (!this.confirmNewPassword) {
       this.errors['confirmNewPassword'] = ['Please enter Confirm Password'];
     } else if (this.newPassword != this.confirmNewPassword) {
          this.errors['confirmNewPassword'] = ['Confirm Password does not match with New Password'];
        } else {
       delete this.errors['confirmNewPassword'];
     }
   }
   

   return Object.keys(this.errors).length === 0;
 },
    clearForm() {
      this.currentPassword = "";
      this.newPassword = "";
      this.confirmNewPassword = "";
      this.passwordFieldType = "password";
      this.newPasswordFieldType = "password";
      this.confirmPasswordFieldType = "password";
      this.passwordToggleIcon = "EyeOffIcon";
      this.newPasswordToggleIcon = "EyeOffIcon";
      this.confirmPasswordToggleIcon = "EyeOffIcon";
      this.errors = {}
    },
    changePasswordModalToggle() {
      this.clearForm();
      this.$refs["changePasswordModal"].toggle();
    },
    logout() {
      // Remove userData from localStorage
      // ? You just removed token from localStorage. If you like, you can also make API call to backend to blacklist used token
      localStorage.removeItem(useJwt.jwtConfig.storageTokenKeyName);
      localStorage.removeItem(useJwt.jwtConfig.storageRefreshTokenKeyName);

      // Remove userData from localStorage
      localStorage.removeItem("userData");

      // Reset ability
      this.$ability.update(initialAbility);

      // Redirect to login page
      this.$router.push({ name: "login" });
    },
    changePassword() {
      // this.$refs.changePasswordForm.validate().then((success) => {
        if (this.checkValidation()) {
          this.isChangePasswordSubmit = true;
          let formData = new FormData();
          formData.append("current_password", this.currentPassword);
          formData.append("new_password", this.newPassword);

          const appLoading = document.getElementById("loading-bg");
          if (appLoading) {
            appLoading.style.display = "block";
          }

          store
            .dispatch("user-nav/changePassword", formData)
            .then((response) => {
              if (response.data.status == true) {
                this.showToast(
                  "success",
                  "CheckCircleIcon",
                  response.data.title,
                  response.data.message
                );
                this.isChangePasswordSubmit = false;
                this.currentPassword = "";
                this.newPassword = "";
                this.confirmNewPassword = "";
                this.$refs["changePasswordModal"].hide();
              } else {
                if (response.data.errors) {
                  this.errors = response.data.errors;
                } else {
                  this.showToast(
                    "danger",
                    "AlertCircleIcon",
                    response.data.title,
                    response.data.message
                  );
                }
                this.isChangePasswordSubmit = false;
              }
              appLoading.style.display = "none";
            })
            .catch(() => {
              appLoading.style.display = "none";
              this.currentPassword = "";
              this.newPassword = "";
              this.confirmNewPassword = "";
            });
        }
      // });
    },
    profile() {
      this.$router.push({ name: "user-profile" });
    },
    showToast(variant, icon, title, message) {
      toast({
        component: ToastificationContent,
        props: {
          title,
          icon,
          text: message,
          variant,
        },
      });
    },
  },
};
</script>

<style scoped scss>
/* div.is-invalid {border: 1px solid red;} */
/* div.is-invalid .form-control {border: none;} */
/* div.is-invalid .input-group-append {border: none;} */
/* div.is-invalid .input-group-text {border: none !important; border-color: white !important;} */

</style>